<template>
    <div uk-slider v-if="problemes.length > 0">
        <div class="uk-position-relative">
            <div class="uk-slider-container">
                <ul class="uk-slider-items uk-grid">
                    <li
                        class="uk-width-1-1"
                        v-for="apprentissageProbleme in problemes"
                        :key="apprentissageProbleme.id"
                    >
                        <div class="uk-panel">
                            <Tesuji
                                :probleme="getProbleme(apprentissageProbleme)"
                                :etapeApprentissage="etapeApprentissage"
                                :idApprentissage="apprentissageProbleme.id"
                                v-if="
                                    isProblemeAvecPossibiliteStandard(
                                        apprentissageProbleme.probleme
                                            .typeProbleme
                                    )
                                "
                            />

                            <Libertes
                                :probleme="getProbleme(apprentissageProbleme)"
                                :etapeApprentissage="etapeApprentissage"
                                :idApprentissage="apprentissageProbleme.id"
                                v-if="
                                    apprentissageProbleme.probleme
                                        .typeProbleme == LIBERTES
                                "
                            />
                            <ChoixMultiple
                                :probleme="getProbleme(apprentissageProbleme)"
                                :etapeApprentissage="etapeApprentissage"
                                :idApprentissage="apprentissageProbleme.id"
                                v-if="
                                    apprentissageProbleme.probleme
                                        .typeProbleme == CHOIXMULTIPLE
                                "
                            />
                        </div>
                    </li>
                </ul>
            </div>

            <div class="uk-visible@s">
                <a
                    class="uk-position-center-left uk-position-small"
                    href="#"
                    uk-slidenav-previous
                    uk-slider-item="previous"
                ></a>
                <a
                    class="uk-position-center-right uk-position-small"
                    href="#"
                    uk-slidenav-next
                    uk-slider-item="next"
                ></a>
            </div>
        </div>

        <ul class="uk-slider-nav uk-dotnav uk-flex-center uk-margin"></ul>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import Tesuji from '../ModeJeu/tesuji/AffichageTesuji.vue';
import Libertes from '../ModeJeu/libertes/AffichageLibertes.vue';
import ChoixMultiple from '../ModeJeu/choixmultiple/AffichageChoixMultiple.vue';
import instancierProbleme from '@/components/outils/InstanciationProbleme';
import * as TypeDeProbleme from '@/components/constantes/TypeDeProbleme';

@Component({
    components: { Tesuji, Libertes, ChoixMultiple }
})
export default class ProblemeCarousel extends Vue {
    @Prop() problemes: any[];
    @Prop() etapeApprentissage: string;

    public LIBERTES = TypeDeProbleme.LIBERTES;
    public CHOIXMULTIPLE = TypeDeProbleme.CHOIXMULTIPLE;

    public getProbleme(carte: Record<string, any>) {
        return instancierProbleme(carte.probleme);
    }

    public isProblemeAvecPossibiliteStandard(type: string): boolean {
        return TypeDeProbleme.isAvecPossibilitesStandard(type);
    }
}
</script>
